// ColleterCPP.cpp : Este arquivo contém a função 'main'. A execução do programa começa e termina ali.
//
#include <windows.h>
#include <iostream>

const char* DLL_LOCATION = "C:\\ted.dll";

typedef int (__stdcall* TTEDStart)(int port);
typedef int (__stdcall* TTEDBeep)(char* ip, int times);
typedef int (__stdcall* TTEDDisplaySend)(char* ip, char* data);
typedef int (__stdcall* TTEDCom1On)(char* ip);
typedef int (__stdcall* TTEDCom1Off)(char* ip);
typedef int (__stdcall* TTEDCom1Send)(char* ip, char* data);
typedef int (__stdcall* TTEDCom2On)(char* ip);
typedef int (__stdcall* TTEDCom2Off)(char* ip);
typedef int (__stdcall* TTEDCom2Send)(char* ip, char* data);
typedef int (__stdcall* TTEDDisplayClear)(char* ip);
typedef int (__stdcall* TTEDListClear)(char* ip);
typedef int (__stdcall* TTEDListAdd)(char* ip, char* data);
typedef int(__stdcall* TTEDHeaderOn)(char* ip);
typedef int(__stdcall* TTEDHeaderOff)(char* ip);
typedef int(__stdcall* TTEDDigitalOn)(char* ip);
typedef int(__stdcall* TTEDDigitalOff)(char* ip);
typedef int(__stdcall* TTEDDigitalRead)(char* ip);

typedef void (*TTEDConnectEvent)(char* ip);
typedef void (*TTEDReceiveEvent)(char* ip, char* data, int header);

typedef void (__stdcall* TOnTEDConnect)(TTEDConnectEvent handler);
typedef void (__stdcall* TOnTEDReceive)(TTEDReceiveEvent handler);

void onTEDConnect(char* ip) {
    std::cout << "TED em " << ip << " conectado!" << std::endl;
}

void onTEDReceive(char* ip, char* data, int header) {
   std::cout << "TED em " << ip << " enviou " << data << " header:" << header << std::endl;
}

int main()
{
    HINSTANCE handler = LoadLibrary((LPCWSTR)DLL_LOCATION);
    if (!handler) {
        std::cout << "nao foi possível carregar biblioteca dinâmica" << std::endl;
        return EXIT_FAILURE;
    }

    TTEDStart tedStart = (TTEDStart)GetProcAddress(handler, "TEDStart");
    if (!tedStart) {
        std::cout << "não foi possível localizar a função TEDStart" << std::endl;
        return EXIT_FAILURE;
    }
    
    if (!tedStart(3000)) {
        std::cout << "não foi possível iniciar o TED na porta 3000" << std::endl;
        return EXIT_FAILURE;
    }

    TOnTEDConnect OnTEDConnect = (TOnTEDConnect)GetProcAddress(handler, "onTEDConnect");
    OnTEDConnect(onTEDConnect);

    std::cout << "TED iniciado com sucesso!" << std::endl;

}
